;;;
;;; Common cruft required to make sxml-tools happy
;;;
;;; These are procedures that are expected, but not provided, by sxml-tools
;;;

(import (only srfi-13 string-prefix? string-index-right
              string-concatenate string-concatenate/shared))

(define string-rindex string-index-right)

(define nl (string #\newline))
(define -- sub1)
(define inc add1)

; like cout << arguments << args
; where argument can be any Scheme object. If it's a procedure
; (without args) it's executed rather than printed (like newline)
(define (cout . args)
  (for-each (lambda (x)
              (if (procedure? x) (x) (display x)))
            args))

(define (cerr . args)
  (for-each (lambda (x)
              (if (procedure? x) (x (current-error-port)) (display x (current-error-port))))
            args))
